package com.dsk.system.service;

import com.dsk.common.core.domain.PageQuery;
import com.dsk.common.core.page.TableDataInfo;
import com.dsk.system.domain.bo.SysTenantBo;
import com.dsk.system.domain.vo.SysTenantVo;

import java.util.Collection;
import java.util.List;

/**
 * @author sxk
 * @date 2023.08.22
 * @description: 企业Service接口
 */
public interface ISysTenantService {
    /**
     * 查询租户列表
     */
    TableDataInfo<SysTenantVo> queryPageList(SysTenantBo bo, PageQuery pageQuery);

//    /**
//     * 查询租户列表
//     */
//    List<SysTenantVo> queryList(SysTenantBo bo);

    /**
     * 禁用所有已过期租户
     */
    void handleExpiredTenant();

    /**
     * 查询租户
     */
    SysTenantVo queryById(Long id);

    /**
     * 校验企业名称是否唯一
     */
    boolean checkCompanyNameUnique(SysTenantBo bo);

    /**
     * 新增租户
     */
    Boolean insertByBo(SysTenantBo bo);

    /**
     * 校验租户是否允许操作
     */
    void checkTenantAllowed(String tenantId);

    /**
     * 修改租户
     */
    Boolean updateByBo(SysTenantBo bo);

//    /**
//     * 修改租户状态
//     */
//    int updateTenantStatus(SysTenantBo bo);

    /**
     * 校验并批量删除租户信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 同步租户套餐
     */
    Boolean syncTenantPackage(String tenantId, Long packageId);

    List<SysTenantVo> selectTenantList(String username);

    /**
     * 基于租户ID查询租户
     */
    SysTenantVo queryByTenantId(String tenantId);

}
